<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Database\Factories\UserFactory;
use Illuminate\Database\Eloquent\Attributes\Fillable;
use Illuminate\Database\Eloquent\Attributes\Hidden;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

#[Fillable(['name', 'email', 'password'])]
#[Hidden(['password', 'remember_token'])]
class User extends Authenticatable
{
    /** @use HasFactory<UserFactory> */
    use HasFactory, Notifiable;

    protected $fillable = [
        'name',
        'email',
        'password',
        'role',
        'mobile_number',
        'photo',
    ];

    protected $hidden = [
        'password',
        'remember_token',
    ];
    protected function casts(): array
    {
        return [
            'email_verified_at' => 'datetime',
            'password' => 'hashed',
        ];
    }

    // Permission Relation
    public function permissions()
    {
        return $this->hasMany(UserPermission::class);
    }

    // Route Access Check Method
    public function hasRouteAccess($routeName)
    {
        // এডমিন হলে সব এক্সেস দিতে চাইলে এখানে লজিক দিতে পারেন (যেমন: if($this->role === 'admin') return true;)
        return $this->permissions()->where('route_name', $routeName)->exists();
    }

    // পারমিশন চেক করার কাস্টম মেথড
    public function hasPermission($routeName)
    {
        // ইউজার যদি 'Admin' হয় তবে সব রুট দেখতে পাবে (ঐচ্ছিক, প্রয়োজন হলে রাখতে পারেন)
        if ($this->role === 'Admin') {
            return true;
        }

        // ডাটাবেজে এই রুটের পারমিশন এন্ট্রি আছে কিনা চেক করবে
        return $this->permissions()->where('route_name', $routeName)->exists();
    }
}
